module Main where

import Types
import ComputationM
import Functions

handleRecipeDir :: Token FilePath -> ComputationM ()
handleRecipeDir dir = do
  dirContents <- listDirectory dir
  imageFilenames <- filterComputationM isImageFilename dirContents
  convertedImageFilenames <- mapComputationM convertedImageFilename imageFilenames
  flip mapComputationM_ (zipTokens imageFilenames convertedImageFilenames) $ \files -> do
    settings <- inject $ ResizeToWidth 800
    convertImage $ tupleTokens files settings

test :: ComputationM ()
test = do
  dir <- inject "retter"
  dirContents <- listDirectory dir
  mapComputationM_ handleRecipeDir dirContents

main :: IO ()
main = mapM_ print $ evalComputationM test
